diff --git a/include/uapi/drm/drm_mode.h b/include/uapi/drm/drm_mode.h
index 9b6722d45f36..8619c7dbb50d 100644
--- a/include/uapi/drm/drm_mode.h
+++ b/include/uapi/drm/drm_mode.h
@@ -757,8 +757,8 @@ struct hdr_metadata_infoframe {
 	 * These are coded as unsigned 16-bit values in units of
 	 * 0.00002, where 0x0000 represents zero and 0xC350
 	 * represents 1.0000.
-	 * @display_primaries.x: X cordinate of color primary.
-	 * @display_primaries.y: Y cordinate of color primary.
+	 * @display_primaries.x: X coordinate of color primary.
+	 * @display_primaries.y: Y coordinate of color primary.
 	 */
 	struct {
 		__u16 x, y;
@@ -768,8 +768,8 @@ struct hdr_metadata_infoframe {
 	 * These are coded as unsigned 16-bit values in units of
 	 * 0.00002, where 0x0000 represents zero and 0xC350
 	 * represents 1.0000.
-	 * @white_point.x: X cordinate of whitepoint of color primary.
-	 * @white_point.y: Y cordinate of whitepoint of color primary.
+	 * @white_point.x: X coordinate of whitepoint of color primary.
+	 * @white_point.y: Y coordinate of whitepoint of color primary.
 	 */
 	struct {
 		__u16 x, y;
diff --git a/include/uapi/drm/exynos_drm.h b/include/uapi/drm/exynos_drm.h
index a51aa1c618c1..27daea06a78e 100644
--- a/include/uapi/drm/exynos_drm.h
+++ b/include/uapi/drm/exynos_drm.h
@@ -187,9 +187,9 @@ struct drm_exynos_ioctl_ipp_get_caps {
 };
 
 enum drm_exynos_ipp_limit_type {
-	/* size (horizontal/vertial) limits, in pixels (min, max, alignment) */
+	/* size (horizontal/vertical) limits, in pixels (min, max, alignment) */
 	DRM_EXYNOS_IPP_LIMIT_TYPE_SIZE		= 0x0001,
-	/* scale ratio (horizonta/vertial), 16.16 fixed point (min, max) */
+	/* scale ratio (horizontal/vertical), 16.16 fixed point (min, max) */
 	DRM_EXYNOS_IPP_LIMIT_TYPE_SCALE		= 0x0002,
 
 	/* image buffer area */
@@ -295,7 +295,7 @@ struct drm_exynos_ipp_task_rect {
 };
 
 /**
- * Image tranformation description.
+ * Image transformation description.
  *
  * @id: must be DRM_EXYNOS_IPP_TASK_TRANSFORM
  * @rotation: DRM_MODE_ROTATE_* and DRM_MODE_REFLECT_* values
diff --git a/include/uapi/drm/i915_drm.h b/include/uapi/drm/i915_drm.h
index c2c7759b7d2e..1ad8c1998693 100644
--- a/include/uapi/drm/i915_drm.h
+++ b/include/uapi/drm/i915_drm.h
@@ -995,7 +995,7 @@ struct drm_i915_gem_exec_object {
 struct drm_i915_gem_execbuffer {
 	/**
 	 * List of buffers to be validated with their relocations to be
-	 * performend on them.
+	 * performed on them.
 	 *
 	 * This is a pointer to an array of struct drm_i915_gem_validate_entry.
 	 *
@@ -1067,7 +1067,7 @@ struct drm_i915_gem_exec_object2 {
  * used by the GPU - this flag only disables the synchronisation prior to
  * rendering with this object in this execbuf.
  *
- * Opting out of implicit synhronisation requires the user to do its own
+ * Opting out of implicit synchronisation requires the user to do its own
  * explicit tracking to avoid rendering corruption. See, for example,
  * I915_PARAM_HAS_EXEC_FENCE to order execbufs and execute them asynchronously.
  */
diff --git a/include/uapi/drm/lima_drm.h b/include/uapi/drm/lima_drm.h
index 1ec58d652a5a..4a38ac3442c8 100644
--- a/include/uapi/drm/lima_drm.h
+++ b/include/uapi/drm/lima_drm.h
@@ -134,7 +134,7 @@ struct drm_lima_gem_submit {
 struct drm_lima_gem_wait {
 	__u32 handle;      /* in, GEM buffer handle */
 	__u32 op;          /* in, CPU want to read/write this buffer */
-	__s64 timeout_ns;  /* in, wait timeout in absulute time */
+	__s64 timeout_ns;  /* in, wait timeout in absolute time */
 };
 
 /**
diff --git a/include/uapi/drm/nouveau_drm.h b/include/uapi/drm/nouveau_drm.h
index 853a327433d3..1fab2431df49 100644
--- a/include/uapi/drm/nouveau_drm.h
+++ b/include/uapi/drm/nouveau_drm.h
@@ -178,7 +178,7 @@ struct drm_nouveau_svm_bind {
 
 /*
  * NOUVEAU_BIND_COMMAND__MIGRATE: synchronous migrate to target memory.
- * result: number of page successfuly migrate to the target memory.
+ * result: number of page successfully migrate to the target memory.
  */
 #define NOUVEAU_SVM_BIND_COMMAND__MIGRATE               0
 
diff --git a/include/uapi/drm/vc4_drm.h b/include/uapi/drm/vc4_drm.h
index 2cac6277a1d7..8de7a98ca6ec 100644
--- a/include/uapi/drm/vc4_drm.h
+++ b/include/uapi/drm/vc4_drm.h
@@ -261,7 +261,7 @@ struct drm_vc4_mmap_bo {
  * shader BOs.
  *
  * Since allowing a shader to be overwritten while it's also being
- * executed from would allow privlege escalation, shaders must be
+ * executed from would allow privilege escalation, shaders must be
  * created using this ioctl, and they can't be mmapped later.
  */
 struct drm_vc4_create_shader_bo {
diff --git a/include/uapi/drm/vmwgfx_drm.h b/include/uapi/drm/vmwgfx_drm.h
index 02e917507479..a46ba95f4e5a 100644
--- a/include/uapi/drm/vmwgfx_drm.h
+++ b/include/uapi/drm/vmwgfx_drm.h
@@ -165,7 +165,7 @@ struct drm_vmw_context_arg {
 
 /*************************************************************************/
 /**
- * DRM_VMW_CREATE_SURFACE - Create a host suface.
+ * DRM_VMW_CREATE_SURFACE - Create a host surface.
  *
  * Allocates a device unique surface id, and queues a create surface command
  * for the host. Does not wait for host completion. The surface ID can be
@@ -442,7 +442,7 @@ union drm_vmw_alloc_bo_arg {
  *
  * This IOCTL controls the overlay units of the svga device.
  * The SVGA overlay units does not work like regular hardware units in
- * that they do not automaticaly read back the contents of the given dma
+ * that they do not automatically read back the contents of the given dma
  * buffer. But instead only read back for each call to this ioctl, and
  * at any point between this call being made and a following call that
  * either changes the buffer or disables the stream.